{
===============================================================================
  Copyright (©) 2003. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 04-03-2003
  Versión actual: 1.0.1
  Fecha versión actual: 13-08-2003
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    13-08-2003    Se ha cambiado el intervalo a intervalo de nombre en vez
                  de intervalo de códigos de proveedor.
===============================================================================
}

unit InformeListadoClientes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, InformeBase, FR_IBXDB, FR_Shape, FR_Class, DB, IBCustomDataSet,
  IBQuery, FR_DSet, FR_DBSet, RdxEmpresaActiva;

type
  TdmInformeListadoClientes = class(TdmInformeBase)
    dsTablaClientes: TfrDBDataSet;
    TablaClientes: TIBQuery;
  private
    FNombreIni: String;
    FNombreFin: String;
  protected
    procedure RellenarCabecera(Band: TfrBand); override;
    procedure PrepararConsultas; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property NombreIni : String read FNombreIni write FNombreIni;
    property NombreFin : String read FNombreFin write FNombreFin;
  end;

var
  dmInformeListadoClientes: TdmInformeListadoClientes;

implementation

{$R *.dfm}

{ TdmInformeListadoClientes }

constructor TdmInformeListadoClientes.Create(AOwner: TComponent);
begin
  inherited;
  FNombreInforme := 'ListadoClientes.frf';
end;

procedure TdmInformeListadoClientes.PrepararConsultas;
begin
  inherited;
  with TablaClientes do
  begin
    Database := FBaseDatos;
    Transaction := FTransaccion;
    SQL.Clear;
    SQL.Add('select CLIENTES.CODIGO, CLIENTES.NIFCIF, CLIENTES.NOMBRE, CALLE ');
    SQL.Add('||'', ''||NUMERO AS DIRECCION, TELEFONO1, TELEFONO2, FAX, CORREO ');
    SQL.Add('from CLIENTES left join SUCURSALESCLIENTE on ');
    SQL.Add('(SUCURSALESCLIENTE.CODIGOCLIENTE = CLIENTES.CODIGO and ');
    SQL.Add('SUCURSALESCLIENTE.TIPO = ''P'')' );
    SQL.Add('where upper(CLIENTES.NOMBRE) between upper(:NOMBREINI) and upper(:NOMBREFIN) ');
    SQL.Add('order by CLIENTES.NOMBRE');
    ParamByName('NOMBREINI').AsString := FNombreIni;
    ParamByName('NOMBREFIN').AsString := FNombreFin;
    Prepare;
  end;
end;

procedure TdmInformeListadoClientes.RellenarCabecera(Band: TfrBand);
var
  iCont : Integer;
  Objeto : TfrView;
begin
  inherited;
  with Band do
  begin
     for iCont := 0 to Objects.Count - 1 do
      begin
        Objeto := Objects[iCont];
        if ((Objeto is TfrMemoView) and (Objeto.Name = 'CabParametros')) then
        begin
          with (Objeto as TfrMemoView) do
          begin
            Memo.Clear;
            Memo.Add('Rango de clientes: ' + FNombreIni + ' - ' + FNombreFin);
          end;
        end;
      end;
  end;
end;

end.

